//
//  SPMakePaymentController.swift
//  SubPaisaPaymentSDK
//
//  Created by Amit Singh on 28/04/20.
//  Copyright © 2020 Amit Singh. All rights reserved.
//

import UIKit
import WebKit
import CryptoSwift
class SPMakePaymentController: UIViewController {
    
    var webView = WKWebView(frame: .zero)
    let activityIndicator = UIActivityIndicatorView(style: .gray)
    
    let userName = "Ish988@sp"
    let password = "wF2F0io7gdNj"
    let txnId = "";
    let clientCode = "NITE5";
    let authKey = "vuQy2eFx4q095E03";
    let authIV = "qz7zPW07upqREhuo";
    var txnAmt = "";
    let successUrl = "https://securetest.sabpaisa.in/SabPaisaClientTest/clientResponse.jsp";
    let failureUrl = "https://securetest.sabpaisa.in/SabPaisaClientTest/clientResponse.jsp";
    var payerFirstName = "";
    var payerLastName = "";
    var payerContact = "";
    var payerEmail = "";
    var payerAddress = "";
    let auth = false;
    
    var aes: AES!
    
    
    override init(nibName nibNameOrNil: String?, bundle nibBundleOrNil: Bundle?) {
        super.init(nibName: nibNameOrNil, bundle: nibBundleOrNil)
    }
    
    required init?(coder: NSCoder) {
        super.init(coder: coder)
    }
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        do {
            aes = try AES.init(key: authKey, iv: authIV)
        } catch {
            print(error)
        }
        
        initialSetUp()
    }
    
    private func initialSetUp() {
        view.backgroundColor = .white
        view.addSubview(webView)
        view.addSubview(activityIndicator)
        
        activityIndicator.translatesAutoresizingMaskIntoConstraints = false
        activityIndicator.centerXAnchor.constraint(equalTo: view.centerXAnchor).isActive = true
        activityIndicator.centerYAnchor.constraint(equalTo: view.centerYAnchor).isActive = true
        
        webView.translatesAutoresizingMaskIntoConstraints = false
        webView.leadingAnchor.constraint(equalTo: view.leadingAnchor).isActive = true
        webView.trailingAnchor.constraint(equalTo: view.trailingAnchor).isActive = true
        webView.topAnchor.constraint(equalTo: view.topAnchor).isActive = true
        webView.bottomAnchor.constraint(equalTo: view.bottomAnchor).isActive = true
        loadWebViewRequest()
    }
    
    func getEncyptedQueryString() -> String {
        
        let query = "?clientName=\(clientCode)&usern=\(userName)&pass=\(password)&amt=\(txnAmt)&txnId=\(randomString(length: 10))&firstName=\(payerFirstName)&lstName=\(payerLastName)&contactNo=\(payerContact)&Email=\(payerEmail)&Add=\(payerAddress)&ru=\(successUrl)&failureURL=\(failureUrl)"
        
        do {
            let ciperText = try aes.encrypt(query.bytes)
            return ciperText.toBase64()!
        } catch {
            return ""
        }
    }
    
    private func loadWebViewRequest() {
        
        activityIndicator.startAnimating()
        let urlString = "https://securepay.sabpaisa.in/SabPaisa/sabPaisaInit?query=\(getEncyptedQueryString().replacingOccurrences(of: "+", with: "%2B"))&clientName=\(clientCode)"
        
        if let requestUrl = URL(string: urlString) {
            webView.navigationDelegate = self
            webView.uiDelegate = self
            let request = URLRequest(url: requestUrl)
            webView.load(request)
        }
    }
}
extension SPMakePaymentController: WKNavigationDelegate, WKUIDelegate {
    
    // MARK: - WebView Methods
    func webView(_ webView: WKWebView, didFinish navigation: WKNavigation!) {
        
        print("Finished")
        activityIndicator.stopAnimating()
    }
    
    func webView(_ webView: WKWebView, decidePolicyFor navigationResponse: WKNavigationResponse, decisionHandler: @escaping (WKNavigationResponsePolicy) -> Void) {
        
        guard let response = navigationResponse.response as? HTTPURLResponse else {
            return
        }
        
        if let requestUrl = response.url?.absoluteString, !requestUrl.isEmpty {
            
            if (requestUrl.contains("resQuery")) && (requestUrl.contains("resClientCode")) {
                
                var encryptedQuery = response.url?.absoluteString.slice(from: "resQuery=", to: "&resClientCode")
                encryptedQuery = encryptedQuery?.replacingOccurrences(of: "%2B", with: "+").replacingOccurrences(of: "%2F", with: "/")
                
                do {
                    guard encryptedQuery != "" else {
                        return
                    }
                    if let encryptedData = Data(base64Encoded: encryptedQuery!) {
                        let decryptedData = Data(try aes.decrypt(encryptedData.bytes))
                        let decryptedResponse = String(data: decryptedData, encoding: .utf8)
                        
                        
                        let responseArray = decryptedResponse?.components(separatedBy: "&") ?? []
                        
                        for component in responseArray {
                            
                            let finalComponent = component.components(separatedBy: "=")
                            
                            switch finalComponent.first {
                            case "PGTxnNo":
                                print("Txn Number",finalComponent.last as Any)
                                
                            case "SabPaisaTxId":
                                print("Sub Paisa Txn Number",finalComponent.last as Any)
                                
                            case "amount":
                                print("Sub Paisa Amount",finalComponent.last as Any)
                                
                            case "reMsg":
                                showAlert(message: finalComponent.last ?? "")
                                
                            default:
                                break
                            }
                        }
                    }
                } catch let error {
                    print(error)
                }
            }
        }
        decisionHandler(.allow)
    }
    
    func webView(_ webView: WKWebView, didFailProvisionalNavigation navigation: WKNavigation!, withError error: Error) {
        print("Failed didFailProvisionalNavigation")
    }
    
    func webView(_ webView: WKWebView, didFail navigation: WKNavigation!, withError error: Error) {
        print("Failed didFail")
    }
    
    func randomString(length: Int) -> String {
        let letters = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789"
        return String((0..<length).map{ _ in letters.randomElement()! })
    }
    
    private func showAlert(message: String) {
        let alert = UIAlertController(title: "SP SDK Demo", message: message, preferredStyle: .alert)
        alert.addAction(UIAlertAction(title: "Okay", style: .default, handler: nil))
        self.present(alert, animated: true)
    }
}
extension String {
    func slice(from: String, to: String) -> String? {
        
        return (range(of: from)?.upperBound).flatMap { substringFrom in
            (range(of: to, range: substringFrom..<endIndex)?.lowerBound).map { substringTo in
                String(self[substringFrom..<substringTo])
            }
        }
    }
}
