//
//  UserDetailsController.swift
//  SubPaisaPaymentSDK
//
//  Created by Amit Singh on 30/04/20.
//  Copyright © 2020 Amit Singh. All rights reserved.
//

import UIKit

class UserDetailsController: UIViewController {
    
    private let firstNameLabel: UILabel = {
        let label = UILabel()
        label.text = "First Name"
        return label
    }()
    
    private let firstNameTxtField: UITextField = {
        let txtField = UITextField()
        txtField.placeholder = "First Name"
        txtField.borderStyle = .bezel
        return txtField
    }()
    
    private let lastNameLabel: UILabel = {
        let label = UILabel()
        label.text = "Last Name"
        return label
    }()
    
    private let lastNameTxtField: UITextField = {
        let txtField = UITextField()
        txtField.placeholder = "Last Name"
        txtField.borderStyle = .bezel
        return txtField
    }()
    
    private let phoneNumberLabel: UILabel = {
        let label = UILabel()
        label.text = "Contact No"
        return label
    }()
    
    private let phoneNumberTxtField: UITextField = {
        let txtField = UITextField()
        txtField.placeholder = "Phone Number"
        txtField.keyboardType = .phonePad
        txtField.borderStyle = .bezel
        return txtField
    }()
    
    private let emailLabel: UILabel = {
        let label = UILabel()
        label.text = "Email"
        return label
    }()
    
    private let emailTxtField: UITextField = {
        let txtField = UITextField()
        txtField.placeholder = "Email"
        txtField.keyboardType = .emailAddress
        txtField.borderStyle = .bezel
        return txtField
    }()
    
    private let addressLabel: UILabel = {
        let label = UILabel()
        label.text = "Address"
        return label
    }()
    
    private let addressTxtField: UITextField = {
        let txtField = UITextField()
        txtField.placeholder = "Address"
        txtField.keyboardType = .emailAddress
        txtField.borderStyle = .bezel
        return txtField
    }()
    
    private let amountLabel: UILabel = {
        let label = UILabel()
        label.text = "Amount"
        return label
    }()
    
    private let amountTxtField: UITextField = {
        let txtField = UITextField()
        txtField.placeholder = "Amount"
        txtField.keyboardType = .numberPad
        txtField.borderStyle = .bezel
        return txtField
    }()
    
    private let submitButton: UIButton = {
        let button = UIButton()
        button.setTitle("Submit", for: .normal)
        button.titleLabel?.textColor = .white
        button.layer.cornerRadius = 4
        button.backgroundColor = UIColor(red: 0/255, green: 128/255, blue: 255/255, alpha: 1.0)
        button.addTarget(self, action: #selector(submitButtonClicked), for: .touchUpInside)
        return button
    }()
    
    override init(nibName nibNameOrNil: String?, bundle nibBundleOrNil: Bundle?) {
        super.init(nibName: nibNameOrNil, bundle: nibBundleOrNil)
    }
    
    required init?(coder: NSCoder) {
        super.init(coder: coder)
    }
    
    override func viewDidLoad() {
        super.viewDidLoad()
        initialSetup()
    }
    
    private func initialSetup() {
        
        navigationItem.title = "SP SDK Demo"
        
        view.backgroundColor = .white
        view.addSubview(firstNameLabel)
        view.addSubview(firstNameTxtField)
        view.addSubview(lastNameLabel)
        view.addSubview(lastNameTxtField)
        view.addSubview(phoneNumberLabel)
        view.addSubview(phoneNumberTxtField)
        view.addSubview(emailLabel)
        view.addSubview(emailTxtField)
        view.addSubview(addressLabel)
        view.addSubview(addressTxtField)
        view.addSubview(amountLabel)
        view.addSubview(amountTxtField)
        view.addSubview(submitButton)
        
        firstNameLabel.translatesAutoresizingMaskIntoConstraints = false
        firstNameLabel.leadingAnchor.constraint(equalTo: view.leadingAnchor, constant: 20).isActive = true
        firstNameLabel.topAnchor.constraint(equalTo: view.topAnchor, constant: 90).isActive = true
        firstNameLabel.heightAnchor.constraint(equalToConstant: 40).isActive = true
        firstNameLabel.widthAnchor.constraint(equalToConstant: 100).isActive = true
        
        firstNameTxtField.translatesAutoresizingMaskIntoConstraints = false
        firstNameTxtField.leadingAnchor.constraint(equalTo: firstNameLabel.trailingAnchor, constant: 20).isActive = true
        firstNameTxtField.topAnchor.constraint(equalTo: view.topAnchor, constant: 90).isActive = true
        firstNameTxtField.trailingAnchor.constraint(equalTo: view.trailingAnchor, constant: -20).isActive = true
        firstNameTxtField.heightAnchor.constraint(equalToConstant: 40).isActive = true
        
        lastNameLabel.translatesAutoresizingMaskIntoConstraints = false
        lastNameLabel.leadingAnchor.constraint(equalTo: view.leadingAnchor, constant: 20).isActive = true
        lastNameLabel.topAnchor.constraint(equalTo: firstNameLabel.bottomAnchor, constant: 5).isActive = true
        lastNameLabel.heightAnchor.constraint(equalToConstant: 40).isActive = true
        lastNameLabel.widthAnchor.constraint(equalToConstant: 100).isActive = true
        
        lastNameTxtField.translatesAutoresizingMaskIntoConstraints = false
        lastNameTxtField.leadingAnchor.constraint(equalTo: lastNameLabel.trailingAnchor, constant: 20).isActive = true
        lastNameTxtField.topAnchor.constraint(equalTo: lastNameLabel.topAnchor, constant: 0).isActive = true
        lastNameTxtField.trailingAnchor.constraint(equalTo: view.trailingAnchor, constant: -20).isActive = true
        lastNameTxtField.heightAnchor.constraint(equalToConstant: 40).isActive = true
        
        phoneNumberLabel.translatesAutoresizingMaskIntoConstraints = false
        phoneNumberLabel.leadingAnchor.constraint(equalTo: view.leadingAnchor, constant: 20).isActive = true
        phoneNumberLabel.topAnchor.constraint(equalTo: lastNameLabel.bottomAnchor, constant: 5).isActive = true
        phoneNumberLabel.heightAnchor.constraint(equalToConstant: 40).isActive = true
        phoneNumberLabel.widthAnchor.constraint(equalToConstant: 100).isActive = true
        
        phoneNumberTxtField.translatesAutoresizingMaskIntoConstraints = false
        phoneNumberTxtField.leadingAnchor.constraint(equalTo: lastNameLabel.trailingAnchor, constant: 20).isActive = true
        phoneNumberTxtField.topAnchor.constraint(equalTo: phoneNumberLabel.topAnchor, constant: 0).isActive = true
        phoneNumberTxtField.trailingAnchor.constraint(equalTo: view.trailingAnchor, constant: -20).isActive = true
        phoneNumberTxtField.heightAnchor.constraint(equalToConstant: 40).isActive = true
        
        emailLabel.translatesAutoresizingMaskIntoConstraints = false
        emailLabel.leadingAnchor.constraint(equalTo: view.leadingAnchor, constant: 20).isActive = true
        emailLabel.topAnchor.constraint(equalTo: phoneNumberLabel.bottomAnchor, constant: 5).isActive = true
        emailLabel.heightAnchor.constraint(equalToConstant: 40).isActive = true
        emailLabel.widthAnchor.constraint(equalToConstant: 100).isActive = true
        
        emailTxtField.translatesAutoresizingMaskIntoConstraints = false
        emailTxtField.leadingAnchor.constraint(equalTo: lastNameLabel.trailingAnchor, constant: 20).isActive = true
        emailTxtField.topAnchor.constraint(equalTo: emailLabel.topAnchor, constant: 0).isActive = true
        emailTxtField.trailingAnchor.constraint(equalTo: view.trailingAnchor, constant: -20).isActive = true
        emailTxtField.heightAnchor.constraint(equalToConstant: 40).isActive = true
        
        addressLabel.translatesAutoresizingMaskIntoConstraints = false
        addressLabel.leadingAnchor.constraint(equalTo: view.leadingAnchor, constant: 20).isActive = true
        addressLabel.topAnchor.constraint(equalTo: emailLabel.bottomAnchor, constant: 5).isActive = true
        addressLabel.heightAnchor.constraint(equalToConstant: 40).isActive = true
        addressLabel.widthAnchor.constraint(equalToConstant: 100).isActive = true
        
        addressTxtField.translatesAutoresizingMaskIntoConstraints = false
        addressTxtField.leadingAnchor.constraint(equalTo: lastNameLabel.trailingAnchor, constant: 20).isActive = true
        addressTxtField.topAnchor.constraint(equalTo: addressLabel.topAnchor, constant: 0).isActive = true
        addressTxtField.trailingAnchor.constraint(equalTo: view.trailingAnchor, constant: -20).isActive = true
        addressTxtField.heightAnchor.constraint(equalToConstant: 40).isActive = true
        
        amountLabel.translatesAutoresizingMaskIntoConstraints = false
        amountLabel.leadingAnchor.constraint(equalTo: view.leadingAnchor, constant: 20).isActive = true
        amountLabel.topAnchor.constraint(equalTo: addressLabel.bottomAnchor, constant: 5).isActive = true
        amountLabel.heightAnchor.constraint(equalToConstant: 40).isActive = true
        amountLabel.widthAnchor.constraint(equalToConstant: 100).isActive = true
        
        amountTxtField.translatesAutoresizingMaskIntoConstraints = false
        amountTxtField.leadingAnchor.constraint(equalTo: lastNameLabel.trailingAnchor, constant: 20).isActive = true
        amountTxtField.topAnchor.constraint(equalTo: addressLabel.bottomAnchor, constant: 5).isActive = true
        amountTxtField.trailingAnchor.constraint(equalTo: view.trailingAnchor, constant: -20).isActive = true
        amountTxtField.heightAnchor.constraint(equalToConstant: 40).isActive = true
        
        submitButton.translatesAutoresizingMaskIntoConstraints = false
        submitButton.topAnchor.constraint(equalTo: amountTxtField.bottomAnchor, constant: 25).isActive = true
        submitButton.heightAnchor.constraint(equalToConstant: 45).isActive = true
        submitButton.widthAnchor.constraint(equalToConstant: 150).isActive = true
        submitButton.centerXAnchor.constraint(equalTo: view.centerXAnchor).isActive = true
    }
    
    @objc func submitButtonClicked() {
        
        guard isValid() else {
            return
        }
        let vc = SPMakePaymentController()
        vc.payerFirstName = firstNameTxtField.text!
        vc.payerLastName = lastNameTxtField.text!
        vc.payerContact = phoneNumberTxtField.text!
        vc.payerEmail = emailTxtField.text!
        vc.payerAddress = addressTxtField.text!
        vc.txnAmt = amountTxtField.text!
        self.navigationController?.pushViewController(vc, animated: true)
        
    }
    
    private func isValid() -> Bool {
        let isValid = false
        if firstNameTxtField.text == "" {
            showAlert(message: "Please enter your First Name.")
            return isValid
        }
        
        if lastNameTxtField.text == "" {
            showAlert(message: "Please enter your Last Name.")
            return isValid
        }
        
        if phoneNumberTxtField.text == "" {
            showAlert(message: "Please enter your Phone Number.")
            return isValid
        }
        
        if emailTxtField.text == "" {
            showAlert(message: "Please enter your Email.")
            return isValid
        }
        
        if addressTxtField.text == "" {
            showAlert(message: "Please enter your Address.")
            return isValid
        }
        
        if amountTxtField.text == "" {
            showAlert(message: "Please enter Amount.")
            return isValid
        }
        
        return true
        
    }
    
    
    private func showAlert(message: String) {
        let alert = UIAlertController(title: "SP SDK Demo", message: message, preferredStyle: .alert)
        alert.addAction(UIAlertAction(title: "Okay", style: .default, handler: nil))
        self.present(alert, animated: true)
    }
}
